#============================================================================
# install_tar_archive.mk

INSTALL_TAR_ARCHIVE_MK =

# this snippet defines a sequence of shell commands which will
#
#  * unarchive a tarball into a directory
#  * uninstall a directory from a tarball

# To use this, set these shell variables
#
#  archive - the archive file. if not in . it will look for it in $(srcdir)
#  instdir - the directory where the files are to be installed

# TAR must be defined
TAR +=

install_tar_archive =	\
	$(MKDIR_P) "$(DESTDIR)$$instdir" ;\
	if test -f "$$archive"; then d=; else d="$(srcdir)/"; fi;\
	$(TAR) xf "$$d$$archive" -C "$(DESTDIR)/$$instdir"

# using the archive as a source of file and directory names, remove
# them.  To ensure that directories are removed in bottom up fashion,
# sort the list of entries in reverse string length
uninstall_tar_archive = \
	if test -f "$$archive"; then d=; else d="$(srcdir)/"; fi;\
	$(TAR) tf "$$d$$archive" | \
	{ cd  $(DESTDIR)$$instdir;\
	  while read entry ; do \
	    echo "$${\#entry} $$entry";\
	  done \
	  | sort -nr \
	  | cut -d' ' -f2 \
	  | while read entry; do \
	      if   test -f "$$entry"; then rm -f "$$entry" ;\
	      elif test -d "$$entry"; then rmdir "$$entry" ; fi;\
	    done ;\
	}

